;**********************************************************************
;    Filename:	    usbmatr.asm                                       *
;    Date:          2004/2/16                                        *
;    File Version:                                                    *
;**********************************************************************

	list      p=16F84             ; list directive to define processor
	#include <p16F84.inc>         ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;***** VARIABLE DEFINITIONS
w_temp        EQU     0x0C        ; variable used for context saving 
status_temp   EQU     0x0D        ; variable used for context saving

wait_data	EQU	0x10		;wait data
retu_pointa	EQU	0x11		;retu pointa
count_sub2	EQU	0x12		;count sub2 data

taihi		EQU	0x13		;taihi data
moji_mode	EQU	0x14		;moji mode ram

count_data	EQU	0x15		;0.1sec keisoku count ram

moji1		EQU	0x18		;moji(1)
moji2		EQU	0x19		;moji(2)
moji3		EQU	0x1a		;moji(3)
taihi2		EQU	0x1b		;taihi data2

led_data0	EQU	0x20		;LED DATA(0)
led_data1	EQU	0x21		;LED DATA(1)
led_data2	EQU	0x22		;LED DATA(2)
led_data3	EQU	0x23		;LED DATA(3)
led_data4	EQU	0x24		;LED DATA(4)
led_data5	EQU	0x25		;LED DATA(5)
led_data6	EQU	0x26		;LED DATA(6)
led_data7	EQU	0x27		;LED DATA(7)

tm0_setdata	EQU	63h		;255-156=99=63H  156*128=19.968msec
cnt_setdata	EQU	08h		;19.968*8=159.744msec

moji_A		EQU	01h
moji_B		EQU	02h
moji_C		EQU	03h
moji_D		EQU	04h
moji_E		EQU	05h
moji_F		EQU	06h
moji_G		EQU	07h
moji_H		EQU	08h
moji_I		EQU	09h
moji_J		EQU	0ah
moji_K		EQU	0bh
moji_L		EQU	0ch
moji_M		EQU	0dh
moji_N		EQU	0eh
moji_O		EQU	0fh
moji_P		EQU	10h
moji_Q		EQU	11h
moji_R		EQU	12h
moji_S		EQU	13h
moji_T		EQU	14h
moji_U		EQU	15h
moji_V		EQU	16h
moji_W		EQU	17h
moji_X		EQU	18h
moji_Y		EQU	19h
moji_Z		EQU	1ah
moji_sp		EQU	1bh
moji_0		EQU	1ch
moji_1		EQU	1dh
moji_2		EQU	1eh
moji_3		EQU	1fh
moji_4		EQU	20h
moji_5		EQU	21h
moji_6		EQU	22h
moji_7		EQU	23h
moji_8		EQU	24h
moji_9		EQU	25h
moji_wari	EQU	26h
moji_wari2	EQU	27h
moji_dai	EQU	28h
moji_shou	EQU	29h
moji_biku	EQU	2ah
moji_eq		EQU	2bh
moji_tasu	EQU	2ch
moji_hiku	EQU	2dh
moji_kake	EQU	2eh
moji_war	EQU	2fh
moji_kaku	EQU	30h

;**********************************************************************
		ORG     0x000             ; processor reset vector
  		goto    main              ; go to beginning of program

;----------------------------------------------------------------------------------
		ORG     0x004             ; interrupt vector location
		movwf   w_temp            ; save off current W register contents
		movf	STATUS,w          ; move status register into W register
		movwf	status_temp       ; save off contents of STATUS register

		;---------------------------------	
		bcf	INTCON,T0IF
		movlw	tm0_setdata
		movwf	TMR0

		decfsz	count_data,1
		goto	int_end
time_up		movlw	cnt_setdata		
		movwf	count_data
		;--------------------------------
		call	retu_shift
int_end
		;----------------------------------
		movf    status_temp,w     ; retrieve copy of STATUS register
		movwf	STATUS            ; restore pre-isr STATUS register contents
		swapf   w_temp,f
		swapf   w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt
;---------------------------------------------------------------------------------------
main
		call	port_set
		movlw	00h		;port initial set
		movwf	PORTA
		movlw	00h
		movwf	PORTB

		movlw	01h
		movwf	moji_mode

		call	count_init
		movf	count_sub2,0
		call	moji_set_sub2
		call	led_set_sub0

		call	timer0_set
		movlw	cnt_setdata
		movwf	count_data

main_loop
;-------------------------------------- key scan
sw1_key		btfsc	PORTA,3
		goto	next_key
		call	wait_1
		btfsc	PORTA,3
		goto	next_key
					;sw1 on
		call	moji_shift
		call	count_init
		movf	count_sub2,0
		call	moji_set_sub2
		call	led_set_sub0
		
sw1_end		btfss	PORTA,3
		goto	sw1_end
next_key
;-------------------------------------- led disp
		movlw	00h
		movwf	PORTA
		movf	led_data0,0
		movwf	PORTB
		call	wait_1

		movlw	01h
		movwf	PORTA
		movf	led_data1,0
		movwf	PORTB
		call	wait_1

		movlw	02h
		movwf	PORTA
		movf	led_data2,0
		movwf	PORTB
		call	wait_1

		movlw	03h
		movwf	PORTA
		movf	led_data3,0
		movwf	PORTB
		call	wait_1

		movlw	04h
		movwf	PORTA
		movf	led_data4,0
		movwf	PORTB
		call	wait_1

		movlw	05h
		movwf	PORTA
		movf	led_data5,0
		movwf	PORTB
		call	wait_1

		movlw	06h
		movwf	PORTA
		movf	led_data6,0
		movwf	PORTB
		call	wait_1

		movlw	07h
		movwf	PORTA
		movf	led_data7,0
		movwf	PORTB
		call	wait_1

;---------------------------------------
main_next
		goto	main_loop
;-------------------------------------------------------------------------------
led_set_sub0	btfsc	retu_pointa,0
		goto	led_set_s0
		btfsc	retu_pointa,1
		goto	led_set_s1
		btfsc	retu_pointa,2
		goto	led_set_s2
		btfsc	retu_pointa,3
		goto	led_set_s3
		goto	led_set_s4

led_set_s0	movf	moji1,0
		call	led_data_line0
		movwf	led_data0
		movf	moji1,0
		call	led_data_line1
		movwf	led_data1
		movf	moji1,0
		call	led_data_line2
		movwf	led_data2
		movf	moji1,0
		call	led_data_line3
		movwf	led_data3
		movf	moji1,0
		call	led_data_line4
		movwf	led_data4
		movf	moji2,0
		call	led_data_line0
		movwf	led_data5
		movf	moji2,0
		call	led_data_line1
		movwf	led_data6
		movf	moji2,0
		call	led_data_line2
		movwf	led_data7
		return
led_set_s1	call	retu_data_shift	
		movf	moji2,0
		call	led_data_line3
		movwf	led_data7
		return
led_set_s2	call	retu_data_shift		
		movf	moji2,0
		call	led_data_line4
		movwf	led_data7
		return
led_set_s3	call	retu_data_shift
		movf	moji3,0
		call	led_data_line0
		movwf	led_data7
		return
led_set_s4	call	retu_data_shift
		movf	moji3,0
		call	led_data_line1
		movwf	led_data7
		return
;-------------------------------------------------------------------------------
retu_data_shift
		movf	led_data1,0
		movwf	led_data0
		movf	led_data2,0
		movwf	led_data1
		movf	led_data3,0
		movwf	led_data2
		movf	led_data4,0
		movwf	led_data3
		movf	led_data5,0
		movwf	led_data4
		movf	led_data6,0
		movwf	led_data5
		movf	led_data7,0
		movwf	led_data6
		return
;-------------------------------------------------------------------------------
count_init	movlw	00h
		movwf	count_sub2
		movlw	01h
		movwf	retu_pointa
		return
;-------------------------------------------------------------------------------
retu_shift	btfss	retu_pointa,4
		goto	retu_shift2
		movlw	01h
		movwf	retu_pointa
		incf	count_sub2,1	
		movf	count_sub2,0
		call	moji_set_sub2
		movf	moji3,0
		skpz
		goto	retu_shift4
		call	count_init
		movf	count_sub2,0
		call	moji_set_sub2
		goto	retu_shift3
retu_shift4	call	led_set_sub0
		return
retu_shift2	rlf	retu_pointa,1
		bcf	retu_pointa,0
retu_shift3	call	led_set_sub0				
		return
;-------------------------------------------------------------------------------
moji_shift	btfss	moji_mode,3
		goto	moji_shift2
		movlw	01h
		movwf	moji_mode
		return
moji_shift2	rlf	moji_mode,1
		bcf	moji_mode,0
		return		
;-------------------------------------------------------------------------------
moji_set_sub2	btfsc	moji_mode,0
		goto	moji_set_sub20
		btfsc	moji_mode,1
		goto	moji_set_sub21
		btfsc	moji_mode,2
		goto	moji_set_sub22
		goto	moji_set_sub23
moji_set_sub20	movwf	taihi2
		call	moji_set0
		movwf	moji1
		movf	taihi2,0
		addlw	1
		call	moji_set0
		movwf	moji2
		movf	taihi2,0
		addlw	2
		call	moji_set0
		movwf	moji3
		return
moji_set_sub21	movwf	taihi2
		call	moji_set1
		movwf	moji1
		movf	taihi2,0
		addlw	1
		call	moji_set1
		movwf	moji2
		movf	taihi2,0
		addlw	2
		call	moji_set1
		movwf	moji3
		return
moji_set_sub22	movwf	taihi2
		call	moji_set2
		movwf	moji1
		movf	taihi2,0
		addlw	1
		call	moji_set2
		movwf	moji2
		movf	taihi2,0
		addlw	2
		call	moji_set2
		movwf	moji3
		return
moji_set_sub23	movwf	taihi2
		call	moji_set3
		movwf	moji1
		movf	taihi2,0
		addlw	1
		call	moji_set3
		movwf	moji2
		movf	taihi2,0
		addlw	2
		call	moji_set3
		movwf	moji3
		return
;-------------------------------------------------------------------------------
moji_set0	movwf	taihi
		movlw	low(moji00)
		addwf	taihi,1
		movlw	high(moji00)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
moji00		
		retlw	moji_N
		retlw	moji_O
		retlw	moji_N
		retlw	moji_C
		retlw	moji_H
		retlw	moji_A
		retlw	moji_N
		retlw	moji_sp
		retlw	moji_S
		retlw	moji_O
		retlw	moji_F
		retlw	moji_T
		retlw	moji_sp
		retlw	moji_N
		retlw	moji_O
		retlw	00h
;-------------------------------------------------------------------------------
moji_set1	movwf	taihi
		movlw	low(moji10)
		addwf	taihi,1
		movlw	high(moji10)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
moji10		
		retlw	moji_dai
		retlw	moji_P
		retlw	moji_I
		retlw	moji_C
		retlw	moji_1
		retlw	moji_6
		retlw	moji_F
		retlw	moji_8
		retlw	moji_4
		retlw	moji_sp
		retlw	moji_U
		retlw	moji_S
		retlw	moji_B
		retlw	moji_hiku
		retlw	moji_D
		retlw	moji_C
		retlw	moji_hiku
		retlw	moji_M
		retlw	moji_A
		retlw	moji_T
		retlw	moji_R
		retlw	moji_I
		retlw	moji_X
		retlw	moji_shou
		retlw	moji_sp
		retlw	moji_dai
		retlw	moji_P
		retlw	00h
;-------------------------------------------------------------------------------
moji_set2	movwf	taihi
		movlw	low(moji20)
		addwf	taihi,1
		movlw	high(moji20)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
moji20		
		retlw	moji_D
		retlw	moji_E
		retlw	moji_N
		retlw	moji_S
		retlw	moji_H
		retlw	moji_I
		retlw	moji_K
		retlw	moji_O
		retlw	moji_U
		retlw	moji_S
		retlw	moji_A
		retlw	moji_K
		retlw	moji_U
		retlw	moji_sp
		retlw	moji_N
		retlw	moji_O
		retlw	moji_sp
		retlw	moji_Y
		retlw	moji_O
		retlw	moji_R
		retlw	moji_O
		retlw	moji_K
		retlw	moji_O
		retlw	moji_B
		retlw	moji_I
		retlw	moji_sp
		retlw	moji_W
		retlw	moji_O
		retlw	moji_sp
		retlw	moji_T
		retlw	moji_S
		retlw	moji_U
		retlw	moji_T
		retlw	moji_A
		retlw	moji_E
		retlw	moji_Y
		retlw	moji_O
		retlw	moji_U
		retlw	moji_biku
		retlw	moji_sp
		retlw	moji_D
		retlw	moji_E
		retlw	00h
;-------------------------------------------------------------------------------
moji_set3	movwf	taihi
		movlw	low(moji30)
		addwf	taihi,1
		movlw	high(moji30)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
moji30		
		retlw	moji_A
		retlw	moji_B
		retlw	moji_C
		retlw	moji_D
		retlw	moji_E
		retlw	moji_F
		retlw	moji_G
		retlw	moji_H
		retlw	moji_I
		retlw	moji_J
		retlw	moji_K
		retlw	moji_L
		retlw	moji_M
		retlw	moji_N
		retlw	moji_O
		retlw	moji_P
		retlw	moji_Q
		retlw	moji_R
		retlw	moji_S
		retlw	moji_T
		retlw	moji_U
		retlw	moji_V
		retlw	moji_W
		retlw	moji_X
		retlw	moji_Y
		retlw	moji_Z
		retlw	moji_sp
		retlw	moji_0
		retlw	moji_1
		retlw	moji_2
		retlw	moji_3
		retlw	moji_4
		retlw	moji_5
		retlw	moji_6
		retlw	moji_7
		retlw	moji_8
		retlw	moji_9
		retlw	moji_wari
		retlw	moji_wari2
		retlw	moji_dai
		retlw	moji_shou
		retlw	moji_biku
		retlw	moji_eq
		retlw	moji_tasu
		retlw	moji_hiku
		retlw	moji_kake
		retlw	moji_war
		retlw	moji_kaku
		retlw	moji_sp
		retlw	moji_A
		retlw	moji_B
		retlw	00h

;-------------------------------------------------------------------------------
led_data_line0	movwf	taihi
		movlw	low(table0)
		addwf	taihi,1
		movlw	high(table0)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
table0		
		retlw	00h		;
		retlw	0fh		;A
		retlw	01fh		;B
		retlw	00eh		;C
		retlw	01fh		;D
		retlw	01fh		;E
		retlw	01fh		;F
		retlw	00eh		;G
		retlw	01fh		;H
		retlw	00h		;I
		retlw	011h		;J
		retlw	01fh		;K
		retlw	01fh		;L
		retlw	01fh		;M
		retlw	01fh		;N
		retlw	0eh		;O
		retlw	01fh		;P
		retlw	0eh		;Q
		retlw	01fh		;R
		retlw	0dh		;S
		retlw	010h		;T
		retlw	01e		;U
		retlw	01ch		;V
		retlw	01fh		;W
		retlw	01bh		;X
		retlw	018h		;Y
		retlw	013h		;Z
		retlw	00h		;
		retlw	01fh		;0
		retlw	00h		;1
		retlw	013h		;2
		retlw	011h		;3
		retlw	01ch		;4
		retlw	01dh		;5
		retlw	01fh		;6
		retlw	018h		;7
		retlw	01fh		;8
		retlw	01dh		;9
		retlw	03h		;/
		retlw	018h		;(/)
		retlw	04h		;<
		retlw	011h		;>
		retlw	00h		;!
		retlw	00h		;=
		retlw	00h		;+
		retlw	00h		;-
		retlw	00h		;*
		retlw	00h		;/
		retlw	00h		;[]

;-------------------------------------------------------------------------------
led_data_line1	movwf	taihi
		movlw	low(table1)
		addwf	taihi,1
		movlw	high(table1)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
table1		
		retlw	00h		;
		retlw	014h		;A
		retlw	015h		;B
		retlw	011h		;C
		retlw	011h		;D
		retlw	015h		;E
		retlw	014h		;F
		retlw	011h		;G
		retlw	04h		;H
		retlw	011h		;I
		retlw	011h		;J
		retlw	04h		;K
		retlw	01h		;L
		retlw	08h		;M
		retlw	08h		;N
		retlw	011h		;O
		retlw	014h		;P
		retlw	011h		;Q
		retlw	014h		;R
		retlw	015h		;S
		retlw	010h		;T
		retlw	01h		;U
		retlw	03h		;V
		retlw	02h		;W
		retlw	04h		;X
		retlw	04h		;Y
		retlw	015		;Z
		retlw	00h		;
		retlw	011h		;0
		retlw	011h		;1
		retlw	015h		;2
		retlw	015h		;3
		retlw	04h		;4
		retlw	015h		;5
		retlw	015h		;6
		retlw	010h		;7
		retlw	015h		;8
		retlw	015h		;9
		retlw	06h		;/
		retlw	0ch		;(/)
		retlw	0eh		;<
		retlw	01bh		;>
		retlw	00h		;!
		retlw	0ah		;=
		retlw	04h		;+
		retlw	04h		;-
		retlw	0ah		;*
		retlw	02h		;/
		retlw	0eh		;[]

;-------------------------------------------------------------------------------
led_data_line2	movwf	taihi
		movlw	low(table2)
		addwf	taihi,1
		movlw	high(table2)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
table2		
		retlw	00h		;
		retlw	014h		;A
		retlw	015h		;B
		retlw	011h		;C
		retlw	011h		;D
		retlw	015h		;E
		retlw	014h		;F
		retlw	015h		;G
		retlw	04h		;H
		retlw	01fh		;I
		retlw	01fh		;J
		retlw	0ah		;K
		retlw	01h		;L
		retlw	08h		;M
		retlw	04h		;N
		retlw	011h		;O
		retlw	014h		;P
		retlw	013h		;Q
		retlw	016h		;R
		retlw	015h		;S
		retlw	01fh		;T
		retlw	01h		;U
		retlw	03h		;V
		retlw	02h		;W
		retlw	04h		;X
		retlw	07h		;Y
		retlw	015h		;Z
		retlw	00h		;
		retlw	011h		;0
		retlw	01fh		;1
		retlw	015h		;2
		retlw	015h		;3
		retlw	04h		;4
		retlw	015h		;5
		retlw	015h		;6
		retlw	010h		;7
		retlw	015h		;8
		retlw	015h		;9
		retlw	0ch		;/
		retlw	06h		;(/)
		retlw	01bh		;<
		retlw	0eh		;>
		retlw	01dh		;!
		retlw	0ah		;=
		retlw	0eh		;+
		retlw	04h		;-
		retlw	04h		;*
		retlw	04h		;/
		retlw	0ah		;[]

;-------------------------------------------------------------------------------
led_data_line3	movwf	taihi
		movlw	low(table3)
		addwf	taihi,1
		movlw	high(table3)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
table3		
		retlw	00h		;
		retlw	00fh		;A
		retlw	00ah		;B
		retlw	00ah		;C
		retlw	00eh		;D
		retlw	011h		;E
		retlw	010h		;F
		retlw	016h		;G
		retlw	01fh		;H
		retlw	011h		;I
		retlw	010h		;J
		retlw	011h		;K
		retlw	01h		;L
		retlw	01fh		;M
		retlw	01fh		;N
		retlw	0eh		;O
		retlw	08h		;P
		retlw	0eh		;Q
		retlw	09h		;R
		retlw	016h		;S
		retlw	010h		;T
		retlw	01eh		;U
		retlw	01ch		;V
		retlw	01fh		;W
		retlw	01bh		;X
		retlw	01ch		;Y
		retlw	019h		;Z
		retlw	00h		;
		retlw	01fh		;0
		retlw	01h		;1
		retlw	01dh		;2
		retlw	01fh		;3
		retlw	01fh		;4
		retlw	017h		;5
		retlw	017h		;6
		retlw	01fh		;7
		retlw	01fh		;8
		retlw	01fh		;9
		retlw	018h		;/
		retlw	03h		;(/)
		retlw	011h		;<
		retlw	04h		;>
		retlw	00h		;!
		retlw	0ah		;=
		retlw	04h		;+
		retlw	04h		;-
		retlw	0ah		;*
		retlw	08h		;/
		retlw	0eh		;[]

;-------------------------------------------------------------------------------
led_data_line4	movwf	taihi
		movlw	low(table4)
		addwf	taihi,1
		movlw	high(table4)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
table4		
		retlw	00h		;
		retlw	000h		;A
		retlw	000h		;B
		retlw	000h		;C
		retlw	000h		;D
		retlw	000h		;E
		retlw	000h		;F
		retlw	000h		;G
		retlw	000h		;H
		retlw	000h		;I
		retlw	000h		;J
		retlw	000h		;K
		retlw	00h		;L
		retlw	000h		;M
		retlw	000h		;N
		retlw	00h		;O
		retlw	00h		;P
		retlw	00h		;Q
		retlw	00h		;R
		retlw	000h		;S
		retlw	000h		;T
		retlw	000h		;U
		retlw	000h		;V
		retlw	000h		;W
		retlw	000h		;X
		retlw	000h		;Y
		retlw	000h		;Z
		retlw	00h		;
		retlw	000h		;0
		retlw	00h		;1
		retlw	000h		;2
		retlw	000h		;3
		retlw	000h		;4
		retlw	000h		;5
		retlw	000h		;6
		retlw	000h		;7
		retlw	000h		;8
		retlw	000h		;9
		retlw	000h		;/
		retlw	00h		;(/)
		retlw	000h		;<
		retlw	00h		;>
		retlw	00h		;!
		retlw	00h		;=
		retlw	00h		;+
		retlw	00h		;-
		retlw	00h		;*
		retlw	00h		;/
		retlw	00h		;[]

;-------------------------------------------------------------------------------
wait_1		
		movlw	0ffh
		movwf	wait_data
wait_2
		decfsz	wait_data,1
		goto	wait_2
		return
;-------------------------------------------------------------------------------
port_set				;RA0,RA1,RA2(OUT)
					;RA3(IN)
					;RA4(OUT)
					;RB0,RB1,RB2,RB3,RB4,RB5,RB6,RB7(OUT)
		bsf	STATUS,RP0
		clrf	TRISA
		bsf	TRISA,3
		nop
		clrf	TRISB
		bcf	STATUS,RP0
		return
;-------------------------------------------------------------------------------
timer0_set
		bsf	STATUS,RP0
		movlw	086h		;(1)PORTB NOT PULLUP
					;(0)INTEDG
					;(0)TOCS
					;(0)TOSE
					;(0)PSA
					;(110)1/128
		movwf	OPTION_REG
		bcf	STATUS,RP0
		
		movlw	tm0_setdata
		movwf	TMR0
		bsf	INTCON,T0IE
		bsf	INTCON,GIE
		return
;-----------------------------------------------------------------------------
		END                     ; directive 'end of program'

